/**
SADJMtd:
	SIN = stock in
	SOUT = Stock Out
	RD = Rounding (penyesuaian stock dibebankan / di round ke HPP itu sendiri 
	RPL = Replace HPP yg ada dilawankan ke akun
	PL = alias. ACC (dibebankan ke akun keuntungan/kerugian) Profit/Loss
**/

CREATE OR REPLACE FUNCTION spSAdj_New (
	_SAdjNo		VARCHAR(15)
) RETURNS SETOF SPStatus AS 
$BODY$
DECLARE
	_retval			SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;
	_spretstockad_new	SPStatus%ROWTYPE;
	
	cSadjD			REFCURSOR;
	cStockAD		REFCURSOR;

	_SadjDate		DATE;
	_SadjType		VARCHAR;
	_SadjMtd		VARCHAR;
	_CrtBy			VARCHAR;
	_CrtDate		TIMESTAMP;
	_UpdBy			VARCHAR;
	_UpdDate		TIMESTAMP;
	_SADJAccNo		VARCHAR;
	_SadjTypeDesc		VARCHAR;
	_Cnt			INT;
	_StockADNo		INT2;
	_SadjDNo		INT;
	_ItemID			VARCHAR;
	_WhID			VARCHAR;
	_Qty			NUMERIC(15,4);
	_Unit			VARCHAR;
	_Cost			NUMERIC(19,4);
	_PID			VARCHAR;
	_QtyX			NUMERIC(15,4);
	_StockANote		VARCHAR;
	_StockANo		VARCHAR;
	_AvgCost		NUMERIC(19,4);
	_StockADCost		NUMERIC(19,4);
	_JnlNo			VARCHAR;
	_JnlNote		VARCHAR;
	_JnlType		VARCHAR;
	_Round			INT;
	_Count			INT;
	_CountSAdj		INT;
	_total			NUMERIC(19,4);
	_DK			VARCHAR;
	_AccInv			VARCHAR;
	_DeptID			VARCHAR;
	_PrjID			VARCHAR;
	_CostNow		NUMERIC(19,4);
	_LockDate		DATE;
	_CrcID			VARCHAR;
	_ExcRate		NUMERIC(19,4);
	_FisRate		NUMERIC(19,4);
	_AccNo			VARCHAR;
	_RefType		VARCHAR;
	_EmpID			VARCHAR;
	_SAdjNote		VARCHAR;
	_PerID			VARCHAR;
	_BranchID		VARCHAR;
	_Conv			NUMERIC(19,4);
	_isDraft		BOOL;

	_StockQty		NUMERIC(19,4);
	_StockSubtotal		NUMERIC(19,4);
	_Subtotal		NUMERIC(19,4);
	_AvgCostRPL		NUMERIC(19,4);
BEGIN
/**
	_retval:=(0, 'OK');
	RETURN NEXT _retval;
	RETURN;
**/
	_retval:=(0, 'OK');

	SELECT INTO _SadjDate,_SAdjType, _SAdjMtd, _CrtBy, _CrtDate, _UpdBy, _UpdDate, _SADJAccNo, _EmpID, _SAdjNote, _PerID, _BranchID, _isDraft
		sadjdate, sadjtype, sadjmtd, crtby, crtdate, updby, upddate, sadjaccno, empid, sadjNote, perid, branchid, isdraft 
	FROM sadj WHERE sadjno=_SAdjNo;

	IF NOT FOUND THEN
		_retval.ErrNo:=50001;
		_retval.ErrMsg:='Transaksi stock #'||_SadjNo|| ' tidak ditemukan! (spSAdj_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	IF (_isDraft IS NOT NULL AND _isDraft=TRUE) THEN
		_retval:=(0, 'OK');
		RETURN NEXT _retval;
		RETURN;
	END IF;


	IF EXISTS (
		SELECT d.* 
		FROM sadjd d 
		JOIN item i ON d.itemid=i.itemid
		WHERE d.unit!=i.unit1 AND d.unit!=COALESCE(i.unit2, '') 
		AND d.unit!=COALESCE(i.unit3, '') AND d.sadjno=_SAdjNo
	) THEN
		_retval.ErrNo:=10001;
		_retval.ErrMsg:=E'Sudah ada perubahan UNIT pada Master Item\nSilahkan re-Open transaksi yang ingin di-edit';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	SELECT INTO _LockDate lockDATE FROM TLock WHERE TransType='SADJ';
	IF(_LockDate IS NOT NULL AND _LockDate>_SadjDate) THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg='Transaksi stock melebihi batas tanggal kunci transaksi ! (spSAdj_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	IF EXISTS (SELECT 1 FROM sadj m JOIN sadjd d ON d.sadjno=m.sadjno WHERE m.sadjno=_SAdjNo AND sadjmtd<>'RPL' AND qty=0) THEN 
		_retval.ErrNo:=50003;
		_retval.ErrMsg='Qty tidak boleh ada yang nol ! (spSAdj_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	SELECT INTO _SadjTypeDesc sadjtypedesc FROM sadjtype WHERE sadjtype=_SadjType;

	SELECT INTO _CrcID crcid FROM crc WHERE isdefault=true;
	_ExcRate:=1;
	_FisRate:=1;

	_Cnt:=1;
	_StockADNo:=0;
	OPEN cSadjD FOR
		SELECT sadjdno, d.itemid, d.whid, qty, unit, cost, pid, qtyx, deptid, prjid
		FROM sadjd d JOIN item i ON d.itemid=i.itemid
		WHERE sadjno=_SadjNo AND i.isstock=true;
	LOOP
		FETCH cSadjD INTO _SadjDNo, _ItemID, _WhID, _Qty, _Unit, _Cost, _PID, _QtyX, _DeptID, _PrjID;
		EXIT WHEN NOT FOUND;

		_PID:=COALESCE(_PID, '');

		SELECT INTO _count COUNT(*) 
		FROM stockad d 
		JOIN stocka h ON d.stockano=h.stockano
		WHERE (h.reftype<>'SADJ' AND h.reftype<>'SIN' AND h.reftype<>'SOUT')
		AND d.itemid=_ItemID AND d.whid=_WhID AND d.pid=_PID;

		IF ((_SAdjType='SADJ' OR _SAdjType='SIN' OR _SAdjType='SOUT') AND (_count IS NULL OR _count=0)) THEN
			_retval.ErrNo:=50001;
			_retval.ErrMsg:='Penyesuaian Stock hanya boleh digunakan untuk pembetulan'||E'\n'||'Item '||_ItemID||', PID:'||_PID||', Gudang: '||_WhID||' belum pernah ada transaksi sebelumnya.'||E'\n'||'Untuk set saldo awal stock gunakan menu Set-Saldo-Awal-Stock atau Pembelian! (spSAdj_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		IF ((_SAdjType='BEG') AND (_count IS NOT NULL AND _count>0)) THEN
			SELECT INTO _countSAdj COUNT(DISTINCT(refno)) 
			FROM stockad d 
			JOIN stocka h ON d.StockANo=h.StockANo
			WHERE (h.reftype<>'SADJ' AND h.reftype<>'SIN' AND h.reftype<>'SOUT')
			AND d.itemid=_ItemID AND d.whid=_WhID AND d.pid=_PID AND h.refno<>_SAdjNo AND (h.branchid IS NULL OR h.branchid=_BranchID);

			IF ((_countSAdj IS NOT NULL AND _countSAdj>0)) THEN
				_retval.ErrNo:=50001;
				_retval.ErrMsg:='Set Saldo Awal Stock hanya boleh digunakan jika belum terjadi transaksi. '||E'\n'||'Item '||_ItemID||', PID:'||_PID||', Gudang: '||_WhID||' Cabang: '||COALESCE(_BranchID,'<kosong>')||' sudah pernah ada transaksi sebelumnya.'||E'\n'||' Gunakan menu Penyesuaian Stock ! (spSAdj_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END IF;

		_StockANote:=_SAdjTypeDesc|| ' #' || _SAdjNo || COALESCE(_SAdjNote,'');

		IF(_Cnt=1) THEN
			_StockADNo:=0;

			SELECT INTO _StockANo * FROM fTransNoGet('STOCKA');
			IF (_StockANo IS NULL) THEN
				_retval.ErrNo:=3;
				_retval.ErrMsg:='ERROR getting StockANo (spSAdj_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			SELECT INTO _spret * FROM spStockA_New(
				_StockANo, NULL, _SadjType, _SadjDate, NULL, _SadjType, _SAdjNo, 
				_StockANote, true, _CrtBy, _CrtDate, _UpdBy, _UpdDate,
				_PerID, _BranchID, _DeptID, _PrjID, _EmpID
			);

			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
			_cnt:=_cnt+1;
		END IF;

		IF((_SAdjType='SIN' OR _SAdjType='SOUT') AND _Qty<=0) THEN
			_retval.ErrNo:=3;
			_retval.ErrMsg:='Stock '|| CASE WHEN _SAdjType='SIN' THEN 'Masuk' ELSE 'Keluar' END ||' Item : '||_ItemID||' qty tidak boleh negatif ! (spSAdj_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		IF(_SAdjType='SOUT') THEN
			_Qty:=_Qty*-1;
		END IF;

		_Conv:=fItemUnit_Conv(_ItemID, _Unit);

		IF(_SadjType<>'BEG') THEN
			_CostNow:=fUnitCost(_ItemID,_WhID,_PID,_Unit);

			IF(_SadjMtd='PL') THEN
				IF(_SAdjType='SIN' AND _Cost<>0) THEN
					_AvgCost:=_Cost;
				ELSE
					_AvgCost:=_CostNow;
				END IF;
			ELSIF(_SadjMtd='RD') THEN
				_AvgCost:=0;
			ELSIF(_SadjMtd='RPL') THEN
				_AvgCost:=_Cost;
			END IF;
	
			IF(_SadjMtd='PL' OR _SadjMtd='RD') THEN
				IF (NOT (_SAdjType='SIN' AND _Cost<>0)) THEN
					UPDATE sadjd SET cost=_AvgCost, conv=_Conv WHERE sadjno=_SAdjNo and sadjdno=_SAdjDNo;
				END IF;
			END IF;

			IF(_SadjMtd='RPL') THEN
				SELECT INTO _CostNow avgcost FROM stock WHERE itemid=_ItemID AND whid=_WhID AND PID=_PID;
				UPDATE sadjd SET qty=0, oldcost=_CostNow WHERE sadjno=_SAdjNo and sadjdno=_SAdjDNo;
				_Qty:=0;
			END IF;
		END IF;

		IF(_SadjType='BEG') THEN
			_AvgCost:=_Cost;
		END IF;

		UPDATE sadjd SET conv=_Conv WHERE sadjno=_SAdjNo and sadjdno=_SAdjDNo;
		_StockADNo:=_StockADNo+1;
		_StockADCost:=_AvgCost;
		IF (_PID IS NULL ) THEN
			_PID:='';
		END IF;

		IF (_Qty<0) THEN
			SELECT INTO _StockQty, _StockSubtotal qty, subtotal FROM stock WHERE itemid=_ItemID AND whid=_WhID AND pid=_PID;
			IF (FOUND AND _StockQty>0) THEN
				_Subtotal:=((_Qty*_Conv)/_StockQty)*_StockSubtotal;
			ELSE
				_Subtotal:=_Qty*_StockADCost;
			END IF;

			IF (_SadjMtd='RD') THEN
				_Subtotal:=0;
			END IF;

			SELECT INTO _spret * FROM spStockAD_New(
				_SadjDate,_SadjType, _StockANo, _StockADNo, _WhID, 
				_ItemID, _PID, _Qty, _Unit, _QtyX, _StockADCost, _DeptID, _PrjID, true, _SAdjNo, _Subtotal
			);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		ELSE
			SELECT INTO _spret * FROM spStockAD_New(
				_SadjDate,_SadjType, _StockANo, _StockADNo, _WhID, 
				_ItemID, _PID, _Qty, _Unit, _QtyX, _StockADCost, _DeptID, _PrjID, true, _SAdjNo
			);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END IF;
	END LOOP;
	CLOSE cSadjD;

/********************************* AKUNTANSI ************************************************/

	IF (isAccInstalled() AND (_SadjMtd='RPL' OR _SadjMtd='PL')) THEN
		_JnlNo:=fTransNoGet('JURNAL');
		IF(_SAdjType='BEG') THEN
			IF (_SAdjNote IS NULL OR _SAdjNote='') THEN
				_JnlNote:='Saldo Awal Stock '||':'||_stockano;
			ELSE
				_JnlNote:='Saldo Awal Stock '||':'||_stockano||E' \nKeterangan : '|| _SAdjNote;
			END IF;
			_JnlType:='BEG';
			_AccNo:=fAccDefault('BEGBAL');
		ELSE
			IF (_SAdjNote IS NULL OR _SAdjNote='') THEN
				_JnlNote:= _SadjTypeDesc||' :'||_sadjno;
			ELSE
				_JnlNote:= _SadjTypeDesc||' :'||_sadjno||E' \nKeterangan : '|| _SAdjNote;
			END IF;
			_JnlType:='SADJ';
			_AccNo:=_SADJAccNo;
		END IF;

		
		SELECT INTO _spretstockad_new * FROM spJnl_Insert(
			_JnlNo, _JnlType, _sADJDATE, 'SADJ', _SADjNo,
			_JnlNote,true,true, CAST(0 as NUMERIC(19,4)),
			_CrtBy,_CrtDate,_UpdBy,_UpdDate,
			_PerID, _BranchID, NULL, NULL, _CrcID, _ExcRate, _FisRate
		);
		IF _spretstockad_new.ErrNo<>0 THEN
			_retval.ErrNo:=_spretstockad_new.ErrNo;
			_retval.ErrMsg:=_spretstockad_new.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		_Round:=fReg('ROUND');
		IF(_Round is null) THEN
			_Round:=0;
		END IF;
		_Count:=0;
		_total:=0;

		
		IF(_sadjMtd='PL') THEN
			
			OPEN cStockad FOR
			SELECT fItemAcc(itemid,'INV'),ROUND(SUM(qty*cost),_Round), deptID, prjID
			from sadjd where sadjno=_sadjno
			GROUP BY fItemAcc(itemid,'INV'), deptID, prjID;
			
		ELSIF(_sadjMtd='RPL') THEN
			OPEN cStockad FOR
		SELECT fItemAcc(d.itemid,'INV'),ROUND(SUM(s.qty*avgcost)-SUM(s.qty*oldcost),_Round), deptID, prjID 
			from sadjd d join stock s on d.itemid=s.itemid and d.whid=s.whid and d.pid=s.pid
			where sadjno=_sadjno
			GROUP BY fItemAcc(d.itemid,'INV'), deptID, prjID;
		END IF;

		LOOP
			FETCH cStockad INTO _AccInv,_cost, _deptID, _prjID;
			EXIT WHEN NOT FOUND;

			IF (_SAdjType='SOUT') THEN
				_cost:=_cost*-1;
			END IF;

			_Count:=_Count+1;
			SELECT INTO _spretstockad_new * 
			FROM spJnlD_Insert(_JnlNo,_Count,_AccInv,'D', _cost,_deptID, _prjID, _cost);
				IF _spretstockad_new.ErrNo<>0 THEN
					_retval.ErrNo:=_spretstockad_new.ErrNo;
					_retval.ErrMsg:=_spretstockad_new.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			_total:=_total+_cost;

			_DK:='K';

			_Count:=_Count+1;
			SELECT INTO _spretstockad_new * 
			FROM spJnlD_Insert(_JnlNo,_Count,_AccNo,_DK,_cost,_deptID,_prjID,_cost);

			IF _spretstockad_new.ErrNo<>0 THEN
				_retval.ErrNo:=_spretstockad_new.ErrNo;
				_retval.ErrMsg:=_spretstockad_new.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END LOOP;
		CLOSE cStockad;

		SELECT INTO _spretstockad_new * FROM spJnl_New(_JnlNo);
		IF _spretstockad_new.ErrNo<>0 THEN
			_retval.ErrNo:=_spretstockad_new.ErrNo;
			_retval.ErrMsg:=_spretstockad_new.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	END IF;

	_retval:=(0, 'OK');
	RETURN NEXT _retval;
END;
$BODY$ 
LANGUAGE plpgsql VOLATILE;


